=== debian/changelog ===
bacula (15.0.3-5) unstable; urgency=high

  [ Carsten Leonhardt ]
  * Fix debian/upstream/metadata to point to the upstream gitlab instance

  [ Sven Hartge ]
  * Add lintian overrides for false positives in *_postgresql_tables
  * Fix Lintian warning about wrong field value for BTS URL in patch.
  * Expand templating mechanism for control files
  * Fix lintian overrides for bacula-director-pgsql
  * Revert "use UTF8 encoding for new postgresql databases"
    (LP: #2121318)

 -- Carsten Leonhardt <leo@debian.org>  Mon, 25 Aug 2025 10:13:59 +0200

bacula (15.0.3-4) unstable; urgency=medium

  [ Sven Hartge ]
  * Add support for ZSTD compression.
  * Pull 8d9669fb2 from Upstream git to fix libzstd detection
  * Flip debconf question about DB upgrade space to default to true
    (Closes: #1109499)

  [ Carsten Leonhardt ]
  * Rework handling of database upgrade scripts in regard to shell quoting
    (Closes: #1108272)
  * Show a message when the user decides to abort the upgrade (Closes: #1109565)

  [ Jonas Jelten ]
  * use UTF8 encoding for new postgresql databases

 -- Carsten Leonhardt <leo@debian.org>  Wed, 13 Aug 2025 10:10:27 +0200

bacula (15.0.3-3) unstable; urgency=medium

  [ Jean-Paul Guillonneau ]
  * Add French translation for bacula's debconf messages (Closes: #1102718)

  [ Amar ]
  * Add Arabic translation for bacula's debconf messages

  [ Nuri KÜÇÜKLER ]
  * Add Turkish translation for bacula's debconf messages

 -- Carsten Leonhardt <leo@debian.org>  Thu, 24 Apr 2025 17:00:09 +0200

bacula (15.0.3-2) unstable; urgency=medium

  [ Américo Monteiro ]
  * Updated Portuguese translation for bacula's debconf messages (Closes: #1101955)

  [ Pablo ]
  * Add Galician translation for bacula's debconf messages

  [ Camaleón ]
  * Add Spanish translation for bacula's debconf messages (Closes: #1102352)

  [ Luca Vercelli ]
  * Add Italian translation for bacula's debconf messages (Closes: #1102460)

 -- Carsten Leonhardt <leo@debian.org>  Wed, 09 Apr 2025 21:56:42 +0200

bacula (15.0.3-1) unstable; urgency=medium

  * New upstream version 15.0.3

  [ Sven Hartge ]
  * Refresh patches

 -- Carsten Leonhardt <leo@debian.org>  Sun, 30 Mar 2025 01:02:38 +0100
